;//////////////////////////////
;// Ot@C`
;//////////////////////////////

	#include "hmm.as"
	hmminit 1


;//////////////////////////////
;// ʐݒ
;//////////////////////////////

	title "Microcosm"

	mouse -1

	screenWidth = 640
	screenHeight = 480

	buffer 3, screenWidth, screenHeight, 0
	chgdisp 1
	bgscr 2, screenWidth, screenHeight, 0


;//////////////////////////////
;// ʉBGM̓ǂ݂
;//////////////////////////////

	soundTitle = 1
	dsloadfname "title.wav", soundTitle

	soundStage0 = 2
	dsloadfname "stage0.wav", soundStage0

	soundStage1 = 3
	dsloadfname "stage1.wav", soundStage1

	soundStage2 = 4
	dsloadfname "stage2.wav", soundStage2

	soundStage3 = 5
	dsloadfname "stage3.wav", soundStage3

	soundBack1 = 6
	dsloadfname "back1.wav", soundBack1

	soundBack2 = 7
	dsloadfname "back2.wav", soundBack2

	soundBack3 = 8
	dsloadfname "back3.wav", soundBack3

	soundBoss1 = 9
	dsloadfname "boss1.wav", soundBoss1

	soundBoss2 = 10
	dsloadfname "boss2.wav", soundBoss2

	soundBoss3 = 11
	dsloadfname "boss3.wav", soundBoss3

	soundDamage = 12
	dsloadfname "dmg.wav", soundDamage

	soundExplosion = 13
	dsloadfname "exp.wav", soundExplosion

	soundKnock = 14
	dsloadfname "kin.wav", soundKnock

	soundClear = 15
	dsloadfname "clear.wav", soundClear

	soundEnding = 16
	dsloadfname "ending.wav", soundEnding


;//////////////////////////////
;// ϐ
;//////////////////////////////

*InitGame
	stageCounter = 0
	stageCountMax = 3
	stageClearFlag = 1

	mySpeed = 5
	myShotMax = 3

	enemyCountMax = 50
	enemyShotMax = 200

	scoreShowMax = 10
	burstShowMax = 10

	frameCounter = 0
	levelCounter = 0
	starCounter = 0
	scoreCounter = 0


;//////////////////////////////
;// fJn
;//////////////////////////////

*DemoStart
	backPicture = "black.bmp"
	gosub *FadeIn

	if stageCounter = 0 {
		soundStageNow = soundStage0
		screenFileName = "stage0.scn"
	}
	if stageCounter = 1 {
		soundStageNow = soundStage1
		screenFileName = "stage1.scn"
	}
	if stageCounter = 2 {
		soundStageNow = soundStage2
		screenFileName = "stage2.scn"
	}
	if stageCounter = 3 {
		soundStageNow = soundStage3
		screenFileName = "stage3.scn"
	}
	dsplay soundStageNow, 1

	linePosition = 0
	screenPositionX = 50
	screenPositionY = 340
	gosub *EventStart

*DemoNext
	if linePosition = 4 {
		dsstop soundStageNow
		backPicture = "black.bmp"
		gosub *FadeIn
		wait 200

		if stageCounter = 0 {
			dsplay soundTitle, 1
			backPicture = "title.bmp"
			gosub *FadeIn
			waitCounter = 0
			waitCountMax = 1000
			gosub *WaitKeyPress

			backPicture = "black.bmp"
			gosub *FadeIn
			wait 100
			dsstop soundTitle
			clrobj
			wait 200
		}
		if stageCounter = 3 {
			goto *GameClear
		}
		else {
			goto *GameStart
		}
	}

	waitCounter = 0
	waitCountMax = 200
	gosub *WaitKeyPress

	linePosition+
	gosub *EventMain

goto *DemoNext


;//////////////////////////////
;// ݒ
;//////////////////////////////

*GameStart
	cls 4
	randomize


;//////////////////////////////
;// z`
;//////////////////////////////

	dim enemyActionPattern, enemyCountMax
	dim enemyGraphicKind, enemyCountMax
	dim enemyKind, enemyCountMax
	dim enemyShield, enemyCountMax
	dim enemyShowTimer, enemyCountMax
	dim enemyPositionX, enemyCountMax
	dim enemyPositionY, enemyCountMax
	dim enemyMovePositionX, enemyCountMax
	dim enemyMovePositionY, enemyCountMax

	dim enemyShotFlag, enemyShotMax
	dim enemyShotPositionX, enemyShotMax
	dim enemyShotPositionY, enemyShotMax
	dim enemyShotMovePositionX, enemyShotMax
	dim enemyShotMovePositionY, enemyShotMax

	dim myShotFlag, myShotMax
	dim myShotPositionX, myShotMax
	dim myShotPositionY, myShotMax

	dim scoreShow, scoreShowMax
	dim scoreShowTimer, scoreShowMax
	dim scoreShowFontSize, scoreShowMax
	dim scorePositionX, scoreShowMax
	dim scorePositionY, scoreShowMax

	dim burstShow, burstShowMax
	dim burstShowTimer, burstShowMax
	dim burstPositionX, burstShowMax
	dim burstPositionY, burstShowMax


;//////////////////////////////
;// ̏
;//////////////////////////////

	dim enemyShotCalc, 900
	repeat 900
		calcShot = cnt
		enemyShotCalc.cnt = calcShot * calcShot
	loop


;//////////////////////////////
;// X^[gO
;//////////////////////////////

	bossBattleFlag = 0
	if stageClearFlag = 1 {
		stageCounter++
		stageClearFlag = 0
	}

	repeat stageCountMax
		stageBossFlag.cnt = 0
	loop

	bossCounter = 0
	nextStageTimer = 0

	myPositionX = 295
	myPositionY = 400
	myShieldCounter = 10
	gameOverTimer = 0

	shotTimeCounterCounter = 0


;//////////////////////////////
;// obt@։摜̓ǂ݂
;//////////////////////////////

	buffer 3, 640, 480
	pos 0, 0
	if stageCounter = 1 {
		picload "back1.bmp", 1
	}
	if stageCounter = 2 {
		picload "back2.bmp", 1
	}
	if stageCounter = 3 {
		picload "back3.bmp", 1
	}

	buffer 4, 625, 625
	pos 0, 0
	picload "char.bmp", 1

	buffer 5, 1536, 192
	pos 0, 0
	picload "exp.bmp", 1

	gsel 2, 1
	palcopy 2
	gmode 2


;//////////////////////////////
;// obN~[WbN
;//////////////////////////////

	if stageCounter = 1 {
		soundBackNow = soundBack1
	}
	if stageCounter = 2 {
		soundBackNow = soundBack2
	}
	if stageCounter = 3 {
		soundBackNow = soundBack3
	}
	dsplay soundBackNow, 1


;//////////////////////////////
;// C[`
;//////////////////////////////

*Main
	redraw 2

	color backColor, 0, 0
	backColor = 0

	boxf 0, 0, 640, 480

	gosub *SetBack

	gosub *ShowMessage

	gosub *MyMove

	gosub *MyShot

	if bossBattleFlag = 0 {
		gosub *BossBattle
	}

	if frameCounter \ (25 - levelCounter) = 0 {
		gosub *EnemyBorn
	}

	gosub *EnemyMove

	gosub *EnemyShotMove

	if keyCode & 128 > 0 {
		gosub *Pause
	}

	if myShieldCounter < 1 {
		gameOverTimer++
		gosub *Bomb
	}

	if nextStageTimer > 0 {
		nextStageTimer--
	}
	if nextStageTimer = 1 {
		goto *NextStage
	}

	if gameOverTimer > 100 {
		goto *GameOver
	}

	await 30
	redraw 1

	frameCounter++

	levelCounter = frameCounter / 500 + 1
	if levelCounter > 20 {
		levelCounter = 20
	}

goto *Main


;//////////////////////////////
;// @ړ
;//////////////////////////////

*MyMove
	if myShieldCounter < 1 {
		return
	}

	shotTimeCounter--

	stick keyCode, 79
	if (keyCode & 64 > 0) & (shotTimeCounter < 0) {
		canShotFlag = 1
	}

	calcX = (keyCode >> 2 & 1) - (keyCode & 1)
	calcY = (keyCode >> 3 & 1) - (keyCode >> 1 & 1)

	myPositionX = calcX * mySpeed + myPositionX
	myPositionY = calcY * mySpeed + myPositionY

	if myPositionX < 0 {
		myPositionX = 0
	}
	if myPositionX > 590 {
		myPositionX = 590
	}
	if myPositionY < 0 {
		myPositionY = 0
	}
	if myPositionY > 430 {
		myPositionY = 430
	}

	pos myPositionX, myPositionY
	gcopy 4, 0, 0, 50, 50

return


;//////////////////////////////
;// wi`
;//////////////////////////////

*SetBack
	gmode 1

	copyPosition = copyPosition + 8 \ 480
	pos 0, copyPosition
	gcopy 3, 0, 0, 640, 480 - copyPosition
	if copyPosition ! 0 {
		pos 0, 0
		gcopy 3, 0, 480 - copyPosition, 640, copyPosition
	}

	gmode 2

return


;//////////////////////////////
;// @e
;//////////////////////////////

*MyShot
	repeat myShotMax
		if (canShotFlag = 1) & (myShotFlag.cnt < 1) {
			myShotFlag.cnt = 1
			myShotPositionX.cnt = myPositionX + 12
			myShotPositionY.cnt = myPositionY - 40
			canShotFlag = 0
			shotTimeCounter = 1
		}

		if myShotFlag.cnt < 1 {
			continue
		}

		pos myShotPositionX.cnt, myShotPositionY.cnt
		gcopy 4, 0, 50, 25, 50

		myShotPositionY.cnt = myShotPositionY.cnt - 40

		if myShotPositionY.cnt < -50 {
			myShotFlag.cnt = 0
		}
	loop

return


;//////////////////////////////
;// {X˓O
;//////////////////////////////

*BossBattle
	if stageCounter = 1 {
		if levelCounter < 5 {
			return
		}
	}
	if stageCounter = 2 {
		if levelCounter < 12 {
			return
		}
	}
	if stageCounter = 3 {
		if levelCounter < 20 {
			return
		}
	}

	bossBattleFlag = 1

	dsstop soundBackNow
	if stageCounter = 1 {
		soundBossNow = soundBoss1
	}
	if stageCounter = 2 {
		soundBossNow = soundBoss2
	}
	if stageCounter = 3 {
		soundBossNow = soundBoss3
	}
	dsplay soundBossNow, 1

return


;//////////////////////////////
;// G
;//////////////////////////////

*EnemyBorn
	if (bossBattleFlag = 0) {
		rnd rndKind, 9
	} else {
		if stageCounter = 1 {
			if (stageBossFlag.0 = 0) {
				rndKind = 91
				stageBossFlag.0 = 1
			} else {
				if (stageBossFlag.0 = 1) {
					rndKind = 92
					stageBossFlag.0 = 2
				} else {
					if (stageBossFlag.0 = 2) {
						return
					}
				}
			}
		}
		if stageCounter = 2 {
			if (stageBossFlag.1 = 0) {
				rndKind = 93
				stageBossFlag.1 = 1
			} else {
				return
			}
		}
		if stageCounter = 3 {
			if (stageBossFlag.2 = 0) {
				rndKind = 94
				stageBossFlag.2 = 1
			} else {
				return
			}
		}
	}

	if rndKind = 0 {
		return
	}

	repeat enemyCountMax
		if enemyShield.cnt > 0 {
			continue
		}
		if rndKind = 1 {
			enemyGraphicKind.cnt = 50
			enemyKind.cnt = 1
			enemyShield.cnt = 2
			enemyPositionY.cnt = -50
			enemyMovePositionY.cnt = 10
		}
		if rndKind = 2 {
			enemyGraphicKind.cnt = 100
			enemyKind.cnt = 1
			enemyShield.cnt = 2
			enemyPositionY.cnt = -50
			enemyMovePositionY.cnt = 10
		}
		if rndKind = 3 {
			enemyGraphicKind.cnt = 150
			enemyKind.cnt = 1
			enemyShield.cnt = 2
			enemyPositionY.cnt = -50
			enemyMovePositionY.cnt = 10
		}
		if rndKind = 4 {
			enemyGraphicKind.cnt = 200
			enemyKind.cnt = 1
			enemyShield.cnt = 2
			enemyPositionY.cnt = -50
			enemyMovePositionY.cnt = 10
		}
		if rndKind = 5 {
			enemyGraphicKind.cnt = 250
			enemyKind.cnt = 1
			enemyShield.cnt = 2
			enemyPositionY.cnt = -50
			enemyMovePositionY.cnt = 10
			enemyMovePositionY.cnt = 10
		}
		if rndKind = 6 {
			enemyGraphicKind.cnt = 300
			enemyKind.cnt = 2
			enemyShield.cnt = 4
			enemyPositionY.cnt = -50
			enemyMovePositionY.cnt = 7
		}
		if rndKind = 7 {
			enemyGraphicKind.cnt = 400
			enemyKind.cnt = 3
			enemyShield.cnt = 6
			enemyPositionY.cnt = -50
			enemyMovePositionY.cnt = 5
		}
		if rndKind = 8 {
			enemyGraphicKind.cnt = 500
			enemyKind.cnt = 3
			enemyShield.cnt = 6
			enemyPositionY.cnt = -50
			enemyMovePositionY.cnt = 5
		}
		if rndKind = 91 {
			enemyGraphicKind.cnt = 0
			enemyKind.cnt = 4
			enemyShield.cnt = 20
			enemyPositionY.cnt = -100
			enemyMovePositionY.cnt = 12
		}
		if rndKind = 92 {
			enemyGraphicKind.cnt = 100
			enemyKind.cnt = 4
			enemyShield.cnt = 20
			enemyPositionY.cnt = -100
			enemyMovePositionY.cnt = 12
		}
		if rndKind = 93 {
			enemyGraphicKind.cnt = 200
			enemyKind.cnt = 5
			enemyShield.cnt = 300
			enemyPositionY.cnt = -150
			enemyMovePositionY.cnt = 10
		}
		if rndKind = 94 {
			enemyGraphicKind.cnt = 0
			enemyKind.cnt = 6
			enemyShield.cnt = 1000
			enemyPositionY.cnt = -375
			enemyMovePositionY.cnt = 1
		}

		rnd enemyPositionX.cnt, 640
		enemyMovePositionX.cnt = 10
		enemyShowTimer.cnt = 0

		if enemyKind.cnt < 4 {
			rnd rndPattern, 3
			enemyActionPattern.cnt = rndPattern + 1
		} else {
			enemyActionPattern.cnt = enemyKind.cnt
		}

		break
	loop

return


;//////////////////////////////
;// Gړ
;//////////////////////////////

*EnemyMove
	repeat enemyCountMax
		enemyShowTimer.cnt++

		if enemyShield.cnt < 1 {
			continue
		}

		saveCnt = cnt

		repeat myShotMax
			if myShotFlag.cnt < 1 {
				continue
			}

			knockFlag = 0
			if enemyKind.saveCnt = 6 {
				knockPositionX = (enemyPositionX.saveCnt + 317) - (myShotPositionX.cnt + 12)
				if knockPositionX < 0 {
					knockPositionX = -knockPositionX
				}
				knockPositionY = (enemyPositionY.saveCnt + 187) - (myShotPositionY.cnt + 25)
				if knockPositionY < 0 {
					knockPositionY = -knockPositionY
				}
				if (knockPositionX >= 0) & (knockPositionX < 317) & (knockPositionY >= 0) & (knockPositionY < 187) {
					knockFlag = 1
				}
			}
			if enemyKind.saveCnt = 5 {
				knockPositionX = (enemyPositionX.saveCnt + 75) - (myShotPositionX.cnt + 12)
				if knockPositionX < 0 {
					knockPositionX = -knockPositionX
				}
				knockPositionY = (enemyPositionY.saveCnt + 75) - (myShotPositionY.cnt + 25)
				if knockPositionY < 0 {
					knockPositionY = -knockPositionY
				}
				if (knockPositionX >= 0) & (knockPositionX < 75) & (knockPositionY >= 0) & (knockPositionY < 75) {
					knockFlag = 1
				}
			}
			if enemyKind.saveCnt = 4 {
				knockPositionX = (enemyPositionX.saveCnt + 50) - (myShotPositionX.cnt + 12)
				if knockPositionX < 0 {
					knockPositionX = -knockPositionX
				}
				knockPositionY = (enemyPositionY.saveCnt + 50) - (myShotPositionY.cnt + 25)
				if knockPositionY < 0 {
					knockPositionY = -knockPositionY
				}
				if (knockPositionX >= 0) & (knockPositionX < 50) & (knockPositionY >= 0) & (knockPositionY < 50) {
					knockFlag = 1
				}
			}
			if enemyKind.saveCnt = 3 {
				knockPositionX = (enemyPositionX.saveCnt + 50) - (myShotPositionX.cnt + 12)
				if knockPositionX < 0 {
					knockPositionX = -knockPositionX
				}
				knockPositionY = (enemyPositionY.saveCnt + 50) - (myShotPositionY.cnt + 25)
				if knockPositionY < 0 {
					knockPositionY = -knockPositionY
				}
				if (knockPositionX >= 0) & (knockPositionX < 50) & (knockPositionY >= 0) & (knockPositionY < 50) {
					knockFlag = 1
				}
			}
			if enemyKind.saveCnt = 2 {
				knockPositionX = (enemyPositionX.saveCnt + 50) - (myShotPositionX.cnt + 12)
				if knockPositionX < 0 {
					knockPositionX = -knockPositionX
				}
				knockPositionY = (enemyPositionY.saveCnt + 25) - (myShotPositionY.cnt + 25)
				if knockPositionY < 0 {
					knockPositionY = -knockPositionY
				}
				if (knockPositionX >= 0) & (knockPositionX < 50) & (knockPositionY >= 0) & (knockPositionY < 25) {
					knockFlag = 1
				}
			}
			if enemyKind.saveCnt = 1 {
				knockPositionX = (enemyPositionX.saveCnt + 25) - (myShotPositionX.cnt + 12)
				if knockPositionX < 0 {
					knockPositionX = -knockPositionX
				}
				knockPositionY = (enemyPositionY.saveCnt + 25) - (myShotPositionY.cnt + 25)
				if knockPositionY < 0 {
					knockPositionY = -knockPositionY
				}
				if (knockPositionX >= 0) & (knockPositionX < 25) & (knockPositionY >= 0) & (knockPositionY < 25) {
					knockFlag = 1
				}
			}

			if knockFlag = 1 {
				enemyShield.saveCnt--
				myShotFlag.cnt = 0
				if enemyShield.saveCnt > 0 {
					pos myShotPositionX.cnt, myShotPositionY.cnt
					gcopy 4, 25, 75, 25, 25
					dsplay soundKnock
				}
				else {
					dsplay soundExplosion
					gosub *ShowMessageborn
				}
			}
		loop

		if enemyActionPattern.cnt = 1 {
			gosub *EnemyAction1
		}
		if enemyActionPattern.cnt = 2 {
			gosub *EnemyAction2
		}
		if enemyActionPattern.cnt = 3 {
			gosub *EnemyAction3
		}
		if enemyActionPattern.cnt > 3 {
			gosub *EnemyBoss
		}
	loop

return


;//////////////////////////////
;// GLsp^[1
;//////////////////////////////

*EnemyAction1
	pos enemyPositionX.cnt, enemyPositionY.cnt

	if enemyKind.cnt = 1 {
		gcopy 4, enemyGraphicKind.cnt, 0, 50, 50
	}
	if enemyKind.cnt = 2 {
		gcopy 4, enemyGraphicKind.cnt, 0, 100, 50
	}
	if enemyKind.cnt = 3 {
		gcopy 4, enemyGraphicKind.cnt, 0, 100, 100
	}

	actionX = myPositionX - enemyPositionX.cnt
	actionY = myPositionY - enemyPositionY.cnt

	if actionY < 350 {
		if actionX < 0 {
			enemyMovePositionX.cnt = enemyMovePositionX.cnt - 1
			if enemyMovePositionX.cnt < -25 {
				enemyMovePositionX.cnt = -25
			}
		}
		else {
			enemyMovePositionX.cnt = enemyMovePositionX.cnt + 1
			if enemyMovePositionX.cnt > 25 {
				enemyMovePositionX.cnt = 25
			}
		}
	}

	if actionX < 0 {
		actionX = -actionX
	}

	if actionX < 50 {
		gosub *EnemyShotBorn
	}

	enemyMovePositionY.cnt = 4

	enemyPositionX.cnt = enemyPositionX.cnt + enemyMovePositionX.cnt
	enemyPositionY.cnt = enemyPositionY.cnt + enemyMovePositionY.cnt

	if enemyPositionX.cnt < -50 {
		enemyShield.cnt = 0
	}
	if enemyPositionX.cnt > 640 {
		enemyShield.cnt = 0
	}
	if enemyPositionY.cnt < -50 {
		enemyShield.cnt = 0
	}
	if enemyPositionY.cnt > 480 {
		enemyShield.cnt = 0
	}

return


;//////////////////////////////
;// GLsp^[2
;//////////////////////////////

*EnemyAction2
	pos enemyPositionX.cnt, enemyPositionY.cnt

	if enemyKind.cnt = 1 {
		gcopy 4, enemyGraphicKind.cnt, 0, 50, 50
	}
	if enemyKind.cnt = 2 {
		gcopy 4, enemyGraphicKind.cnt, 0, 100, 50
	}
	if enemyKind.cnt = 3 {
		gcopy 4, enemyGraphicKind.cnt, 0, 100, 100
	}

	actionX = myPositionX - enemyPositionX.cnt

	if enemyShowTimer.cnt < 2 {
		if actionX < 0 {
			enemyMovePositionX.cnt = -6
		}
		else {
			enemyMovePositionX.cnt = 6
		}
	}

	if enemyShowTimer.cnt > 25 {
		enemyMovePositionY.cnt--
		if enemyMovePositionY.cnt < -10 {
			enemyMovePositionY.cnt = -10
		}
	}

	if enemyPositionY.cnt > 200 {
		gosub *EnemyShotBorn
	}

	enemyPositionX.cnt = enemyPositionX.cnt + enemyMovePositionX.cnt
	enemyPositionY.cnt = enemyPositionY.cnt + enemyMovePositionY.cnt

	if enemyPositionX.cnt < -50 {
		enemyShield.cnt = 0
	}
	if enemyPositionX.cnt > 640 {
		enemyShield.cnt = 0
	}
	if enemyPositionY.cnt < -50 {
		enemyShield.cnt = 0
	}
	if enemyPositionY.cnt > 480 {
		enemyShield.cnt = 0
	}

return


;//////////////////////////////
;// GLsp^[3
;//////////////////////////////

*EnemyAction3
	pos enemyPositionX.cnt, enemyPositionY.cnt

	if enemyKind.cnt = 1 {
		gcopy 4, enemyGraphicKind.cnt, 0, 50, 50
	}
	if enemyKind.cnt = 2 {
		gcopy 4, enemyGraphicKind.cnt, 0, 100, 50
	}
	if enemyKind.cnt = 3 {
		gcopy 4, enemyGraphicKind.cnt, 0, 100, 100
	}

	actionX = myPositionX - enemyPositionX.cnt

	if enemyShowTimer.cnt < 2 {
		if actionX < 0 {
			enemyMovePositionX.cnt = -3
		}
		else {
			enemyMovePositionX.cnt = 3
		}
	}

	if enemyPositionY.cnt > 200 {
		enemyMovePositionY.cnt--
	}
	if enemyShowTimer.cnt > 20 {
		if enemyPositionY.cnt < 50 {
			enemyMovePositionY.cnt++
		}
	}
	if enemyPositionY.cnt > 200 {
		gosub *EnemyShotBorn
	}
	if enemyShowTimer.cnt > 20 {
		if enemyPositionY.cnt < 50 {
			gosub *EnemyShotBorn
		}
	}

	enemyPositionX.cnt = enemyPositionX.cnt + enemyMovePositionX.cnt
	enemyPositionY.cnt = enemyPositionY.cnt + enemyMovePositionY.cnt

	if enemyPositionX.cnt < -50 {
		enemyShield.cnt = 0
	}
	if enemyPositionX.cnt > 640 {
		enemyShield.cnt = 0
	}
	if enemyPositionY.cnt < -50 {
		enemyShield.cnt = 0
	}
	if enemyPositionY.cnt > 480 {
		enemyShield.cnt = 0
	}

return


;//////////////////////////////
;// Xe[W{XLI
;//////////////////////////////

*EnemyBoss
	if stageCounter = 1 {
		gosub EnemyBoss1
	}
	if stageCounter = 2 {
		gosub EnemyBoss2
	}
	if stageCounter = 3 {
		gosub EnemyBoss3
	}

return


;//////////////////////////////
;// Xe[WP{Xsp^[
;//////////////////////////////

*EnemyBoss1
	pos enemyPositionX.cnt, enemyPositionY.cnt

	gcopy 4, enemyGraphicKind.cnt, 100, 100, 100

	if enemyPositionX.cnt > 440 {
		enemyMovePositionX.cnt--
	}
	if enemyPositionY.cnt > 200 {
		enemyMovePositionY.cnt--
	}
	if enemyPositionX.cnt < 100 {
		enemyMovePositionX.cnt++
	}
	if enemyPositionY.cnt < 50 {
		enemyMovePositionY.cnt++
	}

	gosub *EnemyShotBorn

	enemyPositionX.cnt = enemyPositionX.cnt + enemyMovePositionX.cnt
	enemyPositionY.cnt = enemyPositionY.cnt + enemyMovePositionY.cnt

return


;//////////////////////////////
;// Xe[WQ{Xsp^[
;//////////////////////////////

*EnemyBoss2
	pos enemyPositionX.cnt, enemyPositionY.cnt

	gcopy 4, enemyGraphicKind.cnt, 100, 150, 150

	actionX = myPositionX - enemyPositionX.cnt - 50

	if actionX < 0 {
		enemyMovePositionX.cnt = -3
	}
	else {
		enemyMovePositionX.cnt = 3
	}

	if enemyPositionY.cnt > 200 {
		enemyMovePositionY.cnt--
	}

	if enemyShowTimer.cnt > 20 {
		if enemyPositionY.cnt < 50 {
			enemyMovePositionY.cnt++
		}
	}

	gosub *EnemyShotBorn
	gosub *EnemyShotBorn
	gosub *EnemyShotBorn

	enemyPositionX.cnt = enemyPositionX.cnt + enemyMovePositionX.cnt
	enemyPositionY.cnt = enemyPositionY.cnt + enemyMovePositionY.cnt

return


;//////////////////////////////
;// Xe[WR{Xsp^[
;//////////////////////////////
*EnemyBoss3
	pos enemyPositionX.cnt, enemyPositionY.cnt

	gcopy 4, enemyGraphicKind.cnt, 250, 625, 375

	enemyPositionX.cnt = 12
	if enemyPositionY.cnt > 0 {
		enemyPositionY.cnt = 0
	}

	gosub *EnemyShotBorn

	enemyPositionX.cnt = enemyPositionX.cnt + enemyMovePositionX.cnt
	enemyPositionY.cnt = enemyPositionY.cnt + enemyMovePositionY.cnt

return


;//////////////////////////////
;// e
;//////////////////////////////
*EnemyShotBorn
	if frameCounter \ (8 - (levelCounter / 4)) > 0 {
		return
	}

	if enemyKind.cnt = 1 {
		enemyActionX = enemyPositionX.cnt + 12
		enemyActionY = enemyPositionY.cnt + 12
		actionX = myPositionX - enemyPositionX.cnt - 12
		actionY = myPositionY - enemyPositionY.cnt - 12
	}
	if enemyKind.cnt = 2 {
		enemyActionX = enemyPositionX.cnt + 37
		enemyActionY = enemyPositionY.cnt + 12
		actionX = myPositionX - enemyPositionX.cnt - 37
		actionY = myPositionY - enemyPositionY.cnt - 12
	}
	if enemyKind.cnt = 3 {
		enemyActionX = enemyPositionX.cnt + 37
		enemyActionY = enemyPositionY.cnt + 37
		actionX = myPositionX - enemyPositionX.cnt - 37
		actionY = myPositionY - enemyPositionY.cnt - 37
	}
	if enemyKind.cnt = 4 {
		enemyActionX = enemyPositionX.cnt + 37
		enemyActionY = enemyPositionY.cnt + 37
		actionX = myPositionX - enemyPositionX.cnt - 37
		actionY = myPositionY - enemyPositionY.cnt - 37
	}
	if enemyKind.cnt = 5 {
		enemyActionX = enemyPositionX.cnt + 62
		enemyActionY = enemyPositionY.cnt + 62
		actionX = myPositionX - enemyPositionX.cnt - 62
		actionY = myPositionY - enemyPositionY.cnt - 62
	}
	if enemyKind.cnt = 6 {
		enemyActionX = enemyPositionX.cnt + 309
		enemyActionY = enemyPositionY.cnt + 147
		actionX = myPositionX - enemyPositionX.cnt - 309
		actionY = myPositionY - enemyPositionY.cnt - 147
	}

	saveActionX = actionX
	if actionX < 0 {
		actionX = -actionX
	}

	saveActionY = actionY
	if actionY < 0 {
		actionY = -actionY
	}

	calcShot = (actionX * actionX) + (actionY * actionY)




	repeat 900
		if calcShot < enemyShotCalc.cnt {
			calcShot = cnt
			break
		}
	loop

	repeat enemyShotMax
		if enemyShotFlag.cnt > 0 {
			continue
		}

		enemyShotFlag.cnt = 1

		enemyShotPositionX.cnt = enemyActionX
		enemyShotPositionY.cnt = enemyActionY

		rnd rndShot, 8
		rndShot = levelCounter / 5 + 3 + rndShot

		enemyShotMovePositionX.cnt = saveActionX * rndShot / calcShot
		enemyShotMovePositionY.cnt = saveActionY * rndShot / calcShot

		break
	loop

return


;//////////////////////////////
;// Geړ & 蔻
;//////////////////////////////
*EnemyShotMove
	repeat enemyShotMax
		if enemyShotFlag.cnt < 1 {
			continue
		}

		enemyShotPositionX.cnt = enemyShotPositionX.cnt + enemyShotMovePositionX.cnt
		enemyShotPositionY.cnt = enemyShotPositionY.cnt + enemyShotMovePositionY.cnt

		if enemyShotPositionX.cnt > 640 {
			enemyShotFlag.cnt = 0
			continue
		}
		if enemyShotPositionX.cnt < -25 {
			enemyShotFlag.cnt = 0
			continue
		}
		if enemyShotPositionY.cnt > 480 {
			enemyShotFlag.cnt = 0
			continue
		}
		if enemyShotPositionY.cnt < -25 {
			enemyShotFlag.cnt = 0
			continue
		}

		pos enemyShotPositionX.cnt, enemyShotPositionY.cnt
		gcopy 4, 25, 50, 25, 25

		actionX = (myPositionX + 25) - (enemyShotPositionX.cnt + 12)
		if actionX < 0 {
			actionX = -actionX
		}

		actionY = (myPositionY + 25) - (enemyShotPositionY.cnt + 12)
		if actionY < 0 {
			actionY = -actionY
		}

		if (actionX >= 0) & (actionX < 10) & (actionY >= 0) & (actionY < 10) {
			repeat enemyShotMax
				enemyShotFlag.cnt--
			loop

			pos enemyShotPositionX.cnt, enemyShotPositionY.cnt
			gcopy 4, 25, 75, 25, 25

			backColor = 128

			dsplay soundDamage

			myShieldCounter--
		}
	loop

return


;//////////////////////////////
;// GLj
;//////////////////////////////

*ShowMessageborn
	starCounter++

	enemyDistance = myPositionY - enemyPositionY.saveCnt
	if enemyDistance < 0 {
		enemyDistance = -enemyDistance
	}

	calcDistance = 480 - enemyDistance / 50

	calcScore = calcDistance * levelCounter

	if (enemyKind.saveCnt = 1) {
		baseScore = 100
	}
	if (enemyKind.saveCnt = 2) {
		baseScore = 500
	}
	if (enemyKind.saveCnt = 3) {
		baseScore = 1000
	}
	if (enemyKind.saveCnt > 3) {
		clearFlag = 1

		bossCounter++

		baseScore = 50000

		if (stageCounter = 1) {
			if (bossCounter < 2) {
				clearFlag = 0
			}
		}

		if (clearFlag = 1) {
			nextStageTimer = 50
		}
	}

	scoreCounter = baseScore * calcScore + scoreCounter

	repeat scoreShowMax
		if scoreShowTimer.cnt > 0 {
			continue
		}

		scoreShow.cnt = baseScore
		scoreShowTimer.cnt = 20
		scoreShowFontSize.cnt = calcDistance




;		scorePositionX.cnt = enemyPositionX.saveCnt
;		scorePositionY.cnt = enemyPositionY.saveCnt




		if enemyKind.cnt = 1 {
			scorePositionX.cnt = enemyPositionX.saveCnt
			scorePositionY.cnt = enemyPositionY.saveCnt
		}
		if enemyKind.cnt = 2 {
			scorePositionX.cnt = enemyPositionX.saveCnt + 25
			scorePositionY.cnt = enemyPositionY.saveCnt
		}
		if enemyKind.cnt = 3 {
			scorePositionX.cnt = enemyPositionX.saveCnt + 25
			scorePositionY.cnt = enemyPositionY.saveCnt + 25
		}
		if enemyKind.cnt = 4 {
			scorePositionX.cnt = enemyPositionX.saveCnt + 25
			scorePositionY.cnt = enemyPositionY.saveCnt + 25
		}
		if enemyKind.cnt = 5 {
			scorePositionX.cnt = enemyPositionX.saveCnt + 50
			scorePositionY.cnt = enemyPositionY.saveCnt + 50
		}
		if enemyKind.cnt = 6 {
			scorePositionX.cnt = enemyPositionX.saveCnt + 237
			scorePositionY.cnt = enemyPositionY.saveCnt + 162
		}





		burstShow.cnt = 0

		break
	loop

return


;//////////////////////////////
;// ̃Xe[W
;//////////////////////////////

*NextStage
	dsstop soundBossNow
	dsplay soundClear

	nextStageTimer = 0
	bossCounter = 0

	waitCounter = 0
	waitCountMax = -1
	gosub *WaitKeyPress

	dsstop soundClear

	cls 4

	stageClearFlag = 1

	goto *DemoStart

return


;//////////////////////////////
;// Q[
;//////////////////////////////

*ShowMessage
	repeat scoreShowMax
		if scoreShowTimer.cnt < 1 {
			continue
		}

		rnd rndRed, 8
		rndRed = rndRed * 32 + 31

		rnd rndGreen, 8
		rndGreen = rndGreen * 32 + 31

		rnd rndBlue, 8
		rndBlue = rndBlue * 32 + 31

		color rndRed, rndGreen, rndBlue
		font "lr SVbN", scoreShowFontSize.cnt * 2 + 8, 17

		pos scorePositionX.cnt, scorePositionY.cnt
		mes scoreShow.cnt * scoreShowFontSize.cnt

		if burstShow.cnt < 17 {
			gcopy 5, 96 * burstShow.cnt, 0, 96, 96
		}

		scorePositionY.cnt++

		burstShow.cnt++

		scoreShowTimer.cnt--
	loop

	font "lr ", 15, 16
	color 255, 255, 255

	pos 570, 5
	mes "stage:" + stageCounter

	pos 5, 5
	mes "Score:" + scoreCounter

	pos 500, 460
	mes "Warning Level:" + levelCounter

	if myShieldCounter < 1 {
		return
	}

	repeat myShieldCounter
		font "lr SVbN", 15, 16
		color 255, cnt * 25, 0

		pos cnt * 10 + 5, 460
		mes ""
	loop

	showStar = ""
	calcDiv = 100
	star100 = starCounter / calcDiv
	calcMod = starCounter - (star100 * calcDiv)
	rnd rndRed, 255
	rnd rndGreen, 255
	rnd rndBlue, 255
	repeat star100
		color rndRed, rndGreen, rndBlue
		showStar = showStar + ""
	loop
	font "lr SVbN", 18, 16
	pos 5, 25
	mes showStar

	showStar = ""
	calcDiv = 10
	star10 = calcMod / calcDiv
	calcMod = calcMod - (star10 * calcDiv)
	repeat star10
		color 255, 255, 0
		showStar = showStar + ""
	loop
	font "lr SVbN", 15, 16
	pos 5, 47
	mes showStar

	showStar = ""
	calcDiv = 1
	star1 = calcMod / calcDiv
	calcMod = calcMod - (star1 * calcDiv)
	repeat star1
		color 100, 100, 0
		showStar = showStar + ""
	loop
	font "lr SVbN", 12, 16
	pos 5, 65
	mes showStar

return


;//////////////////////////////
;// @
;//////////////////////////////

*Bomb
	repeat burstShowMax
		burstShowTimer.cnt--
		if burstShowTimer.cnt < 1 {
			rnd burstShowTimer.cnt, 10
			burstShowTimer.cnt = burstShowTimer.cnt + 10

			rnd burstPositionX.cnt, 50
			burstPositionX.cnt = 25 - burstPositionX.cnt + myPositionX

			rnd burstPositionY.cnt, 50
			burstPositionY.cnt = 25 - burstPositionY.cnt + myPositionY
		}
		pos burstPositionX.cnt, burstPositionY.cnt
		gcopy 5, 96 * cnt, 0, 96, 96

		rnd rndPosition, 10
		rndPosition = rndPosition - 5
		burstPositionX.cnt = burstPositionX.cnt + rndPosition
		burstPositionY.cnt = burstPositionY.cnt + 10
	loop

	rnd rndEffect, 10
	if rndEffect = 0 {
		dsplay soundDamage
		backColor = 128
	}
	if rndEffect = 1 {
		dsplay soundExplosion
		backColor = 255
	}

return


;//////////////////////////////
;// |[Y
;//////////////////////////////

*Pause
	redraw 2

	font "lr SVbN", 40, 19

	rnd rndRed, 8
	rndRed = rndRed * 32 + 31

	rnd rndGreen, 8
	rndGreen = rndGreen * 32 + 31

	rnd rndBlue, 8
	rndBlue = rndBlue * 32 + 31

	color rndRed, rndGreen, rndBlue

	pos 280, 150
	mes "PAUSE"

	pos 100, 250
	mes "DO YOU WANT TO FINISH?"

	pos 240, 300
	mes "(Yes/No)"

	getkey keyY, 89
	if keyY = 1 {
		end
	}
	getkey keyN, 78
	if keyN = 1 {
		return
	}

	await 30

	redraw 1

goto *Pause


;//////////////////////////////
;// Q[I[o[
;//////////////////////////////

*GameOver
	redraw 2

	font "lr SVbN", 40, 19

	rnd rndRed, 8
	rndRed = rndRed * 32 + 31

	rnd rndGreen, 8
	rndGreen = rndGreen * 32 + 31

	rnd rndBlue, 8
	rndBlue = rndBlue * 32 + 31

	color rndRed, rndGreen, rndBlue

	pos 225, 150
	mes "GAME OVER"

	pos 80, 250
	mes "PUSH RETURN TO CONTINUE"

	stick keyCode
	if keyCode & 32 > 0 {
		dsstop soundBackNow
		dsstop soundBossNow
		scoreCounter = 0
		wait 10

		goto *GameStart
	}

	pos 130, 300
	mes "PUSH ESC TO FINISH"

	getkey keyEsc, 27
	if keyEsc = 1 {
		end
	}

	await 30

	redraw 1

goto *GameOver


;//////////////////////////////
;// Q[NA
;//////////////////////////////

*GameClear
	cls 4

	backPicture = "black.bmp"
	gosub *FadeIn

	dsplay soundEnding, 1

	stepCounter = 300
	pictureIndex = 0
	pictureIndexMax = 10

*GameClearSub
	stepCounter++
	if (stepCounter > 300) & (pictureIndex < pictureIndexMax) {
		pictureIndex++
		stepCounter = 0
		bmpnm = "clear" + pictureIndex + ".bmp"
		picload bmpnm
	}
	if pictureIndex = pictureIndexMax {
		waitCounter = 0
		waitCountMax = 1000
		gosub *WaitKeyPress

		dsstop soundEnding
		end
	}

	await 30

goto *GameClearSub


;//////////////////////////////
;// Cxg
;//////////////////////////////

*EventStart
	alloc textBuffer, 32000
	notesel textBuffer
	bload screenFileName, textBuffer
	alloc keepBuffer, 256

	sdim charText, 64, 32

	gosub *EventMain

return

*EventMain
	messagePositionX = screenPositionX
	messagePositionY = screenPositionY

	clrobj

	noteget cgfn, linePosition * 2

	gsel 3
	picload cgfn, 1, 0, 0

	gsel 2
	gmode 1, 640, 480

	pos 0, 0
	gcopy 3, 0, 0, 640, 480

	noteget keepBuffer, linePosition * 2 + 1

	i = 0
	j = 0
	repeat 32
		getstr charText.cnt, keepBuffer, i, ','
		if strsize < 2 {
			break
		}
		i += strsize
		j+
	loop

	font "lr ", 18, 16
	if j > 0 {
		repeat j
			gosub *ShowText
		loop
	}

return


;//////////////////////////////
;// tF[h
;//////////////////////////////

*FadeIn
	gsel 3
	picload backPicture, 1, 0, 0

	gsel 2
	repeat 16
		gmode 3, screenWidth, screenHeight, 16 * cnt

		pos 0, 0
		gcopy 3, 0, 0, screenWidth, screenHeight

		wait 10
	loop

return


;//////////////////////////////
;// 𗧑̓Iɕ\
;//////////////////////////////

*ShowText
	color 0, 0, 0
	pos messagePositionX + 1, messagePositionY + 1
	mes charText.cnt

	color 255, 255, 255
	pos messagePositionX, messagePositionY
	mes charText.cnt

	messagePositionY += 24

return


;//////////////////////////////
;// 莞ԑҋ@
;//////////////////////////////

*WaitKeyPress
	waitCounter++
	if waitCounter=waitCountMax {
		waitCounter = 0
		return
	}

	stick keyCode, 0
	if keyCode = 32 {
		waitCounter = 0
		return
	}

	await 30

goto *WaitKeyPress
